> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nebius.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List

> Returns a list of all mk8s clusters in the specified project.



## OpenAPI

````yaml https://api.nebius.cloud/openapi.json get /mk8s/v1/clusters
openapi: 3.0.3
info:
  title: Nebius API
  version: version not set
servers:
  - url: https://api.nebius.cloud
security:
  - bearerAuth: []
tags:
  - name: nebius.ai.v1.EndpointService
  - name: nebius.ai.v1.JobService
  - name: nebius.applications.v1alpha1.K8sReleaseService
  - name: nebius.audit.v2.AuditEventExportService
  - name: nebius.audit.v2.AuditEventService
  - name: nebius.billing.v1.CalculatorService
  - name: nebius.billing.v1alpha1.CalculatorService
  - name: nebius.billing.v1alpha1.OneTimeExportService
  - name: nebius.capacity.v1.CapacityAllowanceService
  - name: nebius.capacity.v1.CapacityBlockGroupService
  - name: nebius.capacity.v1.CapacityIntervalService
  - name: nebius.capacity.v1.ResourceAdviceService
  - name: nebius.compute.v1.DiskService
  - name: nebius.compute.v1.DiskSnapshotService
  - name: nebius.compute.v1.FilesystemService
  - name: nebius.compute.v1.GpuClusterService
  - name: nebius.compute.v1.ImageService
  - name: nebius.compute.v1.InstanceService
  - name: nebius.compute.v1.MaintenanceService
  - name: nebius.compute.v1.NVLInstanceGroupService
  - name: nebius.compute.v1.NodeService
  - name: nebius.compute.v1.PlatformService
  - name: nebius.dns.v1.RecordService
  - name: nebius.dns.v1.ZoneService
  - name: nebius.iam.v1.AccessKeyService
  - name: nebius.iam.v1.AccessPermitService
  - name: nebius.iam.v1.AuthPublicKeyService
  - name: nebius.iam.v1.FederatedCredentialsService
  - name: nebius.iam.v1.FederationCertificateService
  - name: nebius.iam.v1.FederationService
  - name: nebius.iam.v1.GroupMembershipService
  - name: nebius.iam.v1.GroupService
  - name: nebius.iam.v1.InvitationService
  - name: nebius.iam.v1.ProfileService
  - name: nebius.iam.v1.ProjectService
  - name: nebius.iam.v1.ServiceAccountService
  - name: nebius.iam.v1.SessionManagementService
  - name: nebius.iam.v1.StaticKeyService
  - name: nebius.iam.v1.TenantService
  - name: nebius.iam.v1.TenantUserAccountService
  - name: nebius.iam.v1.TenantUserAccountWithAttributesService
  - name: nebius.iam.v2.AccessKeyService
  - name: nebius.iam.v2.ProjectService
  - name: nebius.iam.v2.TenantService
  - name: nebius.kms.v1.AsymmetricCryptoService
  - name: nebius.kms.v1.AsymmetricKeyService
  - name: nebius.kms.v1.SymmetricCryptoService
  - name: nebius.kms.v1.SymmetricKeyService
  - name: nebius.logging.agentmanager.v1.VersionService
  - name: nebius.logging.v1.LogExportService
  - name: nebius.maintenance.v1alpha1.MaintenanceService
  - name: nebius.mk8s.v1.ClusterService
  - name: nebius.mk8s.v1.NodeGroupService
  - name: nebius.mk8s.v1alpha1.ClusterService
  - name: nebius.mk8s.v1alpha1.NodeGroupService
  - name: nebius.msp.mlflow.v1alpha1.ClusterService
  - name: nebius.msp.postgresql.v1alpha1.BackupService
  - name: nebius.msp.postgresql.v1alpha1.ClusterService
  - name: nebius.mysterybox.v1.PayloadService
  - name: nebius.mysterybox.v1.SecretService
  - name: nebius.mysterybox.v1.SecretVersionService
  - name: nebius.quotas.v1.QuotaAllowanceService
  - name: nebius.registry.v1.ArtifactService
  - name: nebius.registry.v1.RegistryService
  - name: nebius.storage.v1.BucketService
  - name: nebius.storage.v1.TransferService
  - name: nebius.storage.v1alpha1.TransferService
  - name: nebius.tunnel.v1.TunnelService
  - name: nebius.vpc.v1.AllocationService
  - name: nebius.vpc.v1.NetworkService
  - name: nebius.vpc.v1.PoolService
  - name: nebius.vpc.v1.RouteService
  - name: nebius.vpc.v1.RouteTableService
  - name: nebius.vpc.v1.SecurityGroupService
  - name: nebius.vpc.v1.SecurityRuleService
  - name: nebius.vpc.v1.SubnetService
  - name: nebius.vpc.v1.TargetGroupService
  - name: nebius.vpc.v1alpha1.AllocationService
  - name: nebius.vpc.v1alpha1.NetworkService
  - name: nebius.vpc.v1alpha1.PoolService
  - name: nebius.vpc.v1alpha1.ScopeService
  - name: nebius.vpc.v1alpha1.SubnetService
paths:
  /mk8s/v1/clusters:
    get:
      tags:
        - nebius.mk8s.v1.ClusterService
      summary: List
      description: Returns a list of all mk8s clusters in the specified project.
      operationId: ClusterService_List
      parameters:
        - description: ID of the IAM container we are listing the resources in.
          in: query
          name: parentId
          required: true
          schema:
            type: string
        - description: Specifies the maximum number of items to return in the response.
          in: query
          name: pageSize
          schema:
            format: int64
            type: string
        - description: >-
            Token for pagination, allowing the retrieval of the next set of
            results.
          in: query
          name: pageToken
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/mk8sV1ListClustersResponse'
          description: A successful response.
components:
  schemas:
    mk8sV1ListClustersResponse:
      properties:
        items:
          items:
            $ref: '#/components/schemas/mk8sV1Cluster'
          type: array
        nextPageToken:
          type: string
      type: object
    mk8sV1Cluster:
      properties:
        metadata:
          $ref: '#/components/schemas/commonV1ResourceMetadata'
        spec:
          $ref: '#/components/schemas/mk8sV1ClusterSpec'
        status:
          $ref: '#/components/schemas/mk8sV1ClusterStatus'
      type: object
    commonV1ResourceMetadata:
      description: Common resource metadata.
      properties:
        createdAt:
          description: Timestamp indicating when the resource was created.
          format: date-time
          readOnly: true
          type: string
        id:
          description: Identifier for the resource, unique for its resource type.
          type: string
        labels:
          additionalProperties:
            type: string
          description: Labels associated with the resource.
          type: object
        name:
          description: Human readable name for the resource.
          type: string
        parentId:
          description: Identifier of the parent resource to which the resource belongs.
          type: string
        resourceVersion:
          description: >-
            Version of the resource for safe concurrent modifications and
            consistent reads.

            Positive and monotonically increases on each resource spec change
            (but *not* on each change of the

            resource's container(s) or status).

            Service allows zero value or current.
          format: int64
          type: string
        updatedAt:
          description: Timestamp indicating when the resource was last updated.
          format: date-time
          readOnly: true
          type: string
      required:
        - parentId
      type: object
    mk8sV1ClusterSpec:
      properties:
        controlPlane:
          $ref: '#/components/schemas/mk8sV1ControlPlaneSpec'
        kubeNetwork:
          $ref: '#/components/schemas/mk8sV1KubeNetworkSpec'
      required:
        - controlPlane
      type: object
    mk8sV1ClusterStatus:
      properties:
        controlPlane:
          $ref: '#/components/schemas/mk8sV1ControlPlaneStatus'
        events:
          items:
            $ref: '#/components/schemas/v1RecurrentResourceEvent'
          type: array
        reconciling:
          title: Show that changes are in flight
          type: boolean
        state:
          $ref: '#/components/schemas/mk8sV1ClusterStatusState'
      type: object
    mk8sV1ControlPlaneSpec:
      properties:
        auditLogs:
          $ref: '#/components/schemas/v1AuditLogsSpec'
        endpoints:
          $ref: '#/components/schemas/mk8sV1ControlPlaneEndpointsSpec'
        etcdClusterSize:
          description: >-
            Number of instances in etcd cluster.

            3 by default.

            Control plane with `etcd_cluster_size: 3` called "Highly Available"
            ("HA"), because it's Kubernetes API

            will be available despite a failure of one control plane instance.
          format: int64
          type: string
        karpenter:
          $ref: '#/components/schemas/v1Karpenter'
        subnetId:
          description: |-
            Nebius VPC Subnet ID where control plane instances will be located.
            Also will be default NodeGroup subnet.
          type: string
        version:
          description: >-
            Desired Kubernetes version of the cluster. For now only acceptable
            format is

            `<major>.<minor>` like "1.31". Option for patch version update will
            be added later.
          type: string
      required:
        - subnetId
      type: object
    mk8sV1KubeNetworkSpec:
      properties:
        serviceCidrs:
          description: >-
            CIDR blocks for Service ClusterIP allocation.

            For now, only one value is supported.

            Must be a valid CIDR block or prefix length.

            In case of prefix length, certain CIDR is auto allocated.

            Specified CIDR blocks will be reserved in
            Cluster.spec.control_plane.subnet_id to prevent address duplication.

            Allowed prefix length is from "/12" to "/28".

            Empty value treated as ["/16"].
          items:
            type: string
          type: array
      type: object
    mk8sV1ControlPlaneStatus:
      properties:
        auth:
          $ref: '#/components/schemas/mk8sV1ControlPlaneStatusAuth'
        endpoints:
          $ref: '#/components/schemas/mk8sV1ControlPlaneStatusEndpoints'
        etcdClusterSize:
          description: Number of instances in etcd cluster.
          format: int64
          type: string
        version:
          description: >-
            Actual Kubernetes and configuration version.

            Version has format
            `<major>.<minor>.<patch>-nebius-cp.<infra_version>` like

            "1.30.0-nebius-cp.3", where `<major>.<minor>.<patch>` is Kubernetes
            version and `<infra_version>` is version of control plane

            infrastructure and configuration, updating of which may include bug
            fixes, security updates and new features of components running on

            control plane, like CCM or Cluster Autoscaler.
          type: string
      type: object
    v1RecurrentResourceEvent:
      properties:
        firstOccurredAt:
          format: date-time
          title: Time of the first occurrence of a recurrent event
          type: string
        lastOccurrence:
          $ref: '#/components/schemas/v1ResourceEvent'
        occurrenceCount:
          format: int64
          title: >-
            The number of times this event has occurred between
            `first_occurred_at` and `last_occurrence.occurred_at`. Must be > 0
          type: string
      title: >-
        A resource event that has occurred (more or less in the same way)
        multiple times across a service-defined aggregation interval
      type: object
    mk8sV1ClusterStatusState:
      default: STATE_UNSPECIFIED
      enum:
        - STATE_UNSPECIFIED
        - PROVISIONING
        - RUNNING
        - DELETING
      type: string
    v1AuditLogsSpec:
      type: object
    mk8sV1ControlPlaneEndpointsSpec:
      properties:
        publicEndpoint:
          $ref: '#/components/schemas/mk8sV1PublicEndpointSpec'
      type: object
    v1Karpenter:
      type: object
    mk8sV1ControlPlaneStatusAuth:
      properties:
        clusterCaCertificate:
          description: >-
            PEM with the Cluster Certificate Authority, that must be used for
            TLS connection to Kubernetes API.
          type: string
      type: object
    mk8sV1ControlPlaneStatusEndpoints:
      description: >-
        Endpoints of Kubernetes control plane. Kubernetes API can be accessed at
        `https://endpoint/`.
      properties:
        privateEndpoint:
          description: DNS name or IP address accessible from the user VPC.
          type: string
        publicEndpoint:
          description: DNS name or IP address accessible from the Internet.
          type: string
      type: object
    v1ResourceEvent:
      properties:
        code:
          title: >-
            Event code (unique within the API service), in UpperCamelCase, e.g.
            `"DiskAttached"`
          type: string
        error:
          $ref: '#/components/schemas/googleRpcStatus'
        level:
          $ref: '#/components/schemas/ResourceEventLevel'
        message:
          title: >-
            A human-readable message describing what has happened

            (and suggested actions for the user, if this is a `WARN` or `ERROR`
            level event)
          type: string
        occurredAt:
          format: date-time
          title: Time at which the event has occurred
          type: string
      title: >-
        Represents an API Resource-related event which is potentially important
        to the end-user. What exactly constitutes an *event* to be

        reported is service-dependent
      type: object
    mk8sV1PublicEndpointSpec:
      properties:
        allowedCidrs:
          description: >-
            List of CIDR blocks from which access to public endpoint is allowed.

            If field is not set, or list is empty, it means that access is not
            restricted at all.
          items:
            type: string
          type: array
      type: object
    googleRpcStatus:
      description: >-
        The `Status` type defines a logical error model that is suitable for

        different programming environments, including REST APIs and RPC APIs. It
        is

        used by [gRPC](https://github.com/grpc). Each `Status` message contains

        three pieces of data: error code, error message, and error details.


        You can find out more about this error model and how to work with it in
        the

        [API Design Guide](https://cloud.google.com/apis/design/errors).
      properties:
        code:
          description: |-
            The status code, which should be an enum value of
            [google.rpc.Code][google.rpc.Code].
          format: int32
          type: integer
        details:
          description: >-
            A list of messages that carry the error details.  There is a common
            set of

            message types for APIs to use.
          items:
            $ref: '#/components/schemas/protobufAny'
          type: array
        message:
          description: >-
            A developer-facing error message, which should be in English. Any

            user-facing error message should be localized and sent in the

            [google.rpc.Status.details][google.rpc.Status.details] field, or
            localized

            by the client.
          type: string
      type: object
    ResourceEventLevel:
      default: UNSPECIFIED
      enum:
        - UNSPECIFIED
        - DEBUG
        - INFO
        - WARN
        - ERROR
      title: |-
        - UNSPECIFIED: Unspecified event severity level
         - DEBUG: A debug event providing detailed insight. Such events are used to debug problems with specific resource(s) and process(es)
         - INFO: A normal event or state change. Informs what is happening with the API resource. Does not require user attention or interaction
         - WARN: Warning event. Indicates a potential or minor problem with the API resource and/or the corresponding processes. Needs user attention,
        but requires no immediate action (yet)
         - ERROR: Error event. Indicates a serious problem with the API resource and/or the corresponding processes. Requires immediate user action
      type: string
    protobufAny:
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message
      properties:
        '@type':
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
          type: string
      type: object
  securitySchemes:
    bearerAuth:
      description: The Authorization header expects a Bearer token.
      scheme: bearer
      type: http

````